isc.DataSource.create({
    ID:"QuartzTriggers",
    serverConstructor:"com.isomorphic.scheduler.QuartzTriggers",
    fields:[
        {
            name:"jobGroup",
            required:true,
            showIf:"false",
            type:"string"
        },
        {
            name:"jobName",
            required:true,
            showIf:"false",
            type:"string"
        },
        {
            name:"group",
            primaryKey:true,
            required:true,
            type:"string"
        },
        {
            name:"name",
            primaryKey:true,
            required:true,
            type:"string"
        },
        {
            name:"description",
            type:"string"
        },
        {
            name:"dataMap",
            showIf:"false",
            type:"Object"
        },
        {
            name:"startTime",
            type:"date"
        },
        {
            name:"endTime",
            type:"date"
        },
        {
            name:"cronExpression",
            required:true,
            type:"text"
        },
        {
            name:"timeZone",
            type:"text"
        },
        {
            defaultValue:"false",
            name:"volatility",
            type:"boolean"
        },
        {
            defaultValue:"0",
            name:"misfireInstruction",
            type:"intEnum",
            valueMap:{
                "0":"MISFIRE_INSTRUCTION_SMART_POLICY",
                "1":"MISFIRE_INSTRUCTION_FIRE_ONCE_NOW",
                "2":"MISFIRE_INSTRUCTION_DO_NOTHING"
            }
        },
        {
            canEdit:false,
            name:"state",
            type:"intEnum",
            valueMap:{
                "0":"Normal",
                "1":"Paused",
                "2":"Complete",
                "3":"Error",
                "4":"Blocked",
                "-1":"None"
            }
        }
    ]
})
