#!/bin/sh
#
# Startup script for LOGalyze
#
# Copyright © 2007-2012 ZURIEL Kft. All Rights Reserved.
# For more details visit http://www.logalyze.com/
# Contact: support@logalyze.com
#
#
# JVM Parameters (-D)
#
# rc.indexRollingFreq
#     Index rolling frequency
#     Valid values: 1h 12h 24h w m (hourly, half-daily, daily, weekly, monthly)
#     Default: 24h
#
# rc.indexDocNumLimit
#     Maximum number of documents per index (integer)
#     Default: 10 000 000
#
# rc.rawEntryNumLimit
#     Maximum number of log entries in logstore file
#     Default: 0
#
# rc.rawFileSizeThreshold
#     Maximum file size of logstore file in bytes
#     Valid values: 1, 1kB, 1MB, 1GB
#     Default: 0

. $(dirname $0)/setenv.sh

$JAVA_HOME/bin/java \
		-server \
        -Dlog4j.configuration=file:$LOGALYZE_HOME/conf/log4j.conf \
        -Dlogalyze.home=$LOGALYZE_HOME \
        -Drc.indexDocNumLimit=1000000 \
        -cp $(for i in $LOGALYZE_HOME/lib/*.jar ; do echo -n $i: ; done). \
        ${JVM_ARGS} \
        com.logalyze.engine.LOGalyzeEngine $LOGALYZE_HOME/conf/engine.xml 2>&1 >>$LOGALYZE_HOME/logs/logalyze.out &
PID=$!
RETVAL=$?

echo $PID >$PIDFILE

exit $RETVAL
